#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>

static char GAME_URL[1024];

#include <stdio.h>
#include <windows.h>
#include <windowsx.h>

#include <time.h>

#include "dama.h"
#include "resource.h"
#include "resrc1.h"

/*
	STARO:
*/

//#define HOST	"www.mindsports.net"
//#define URL_FMT	"/Arena/htbin/Serve.cgi?file=Dame%s.html"

/*
	NOVO:
*/

#define HOST	"www.mindsports.nl"
#define URL_FMT	"/cgi-bin/Arena/Serve.cgi?file=Dame%s.html"


FILE *log_file = NULL;

static BOOL okreni = FALSE;

#define CONTENT_LENGTH	"Content-Length:"

extern "C" time_t parsedate(char *p);

static char *action = NULL, *playsWhite = NULL, *playsBlack = NULL, *command = "";
static char *endMessage = NULL;
static char *partija = NULL;

static const void time_tToFileTime(FILETIME *ft, long t, long usec)
{
	static const LONGLONG Jan1st1970 = (LONGLONG)116444736000000000;

	LARGE_INTEGER liOffset;
	LONGLONG &date = liOffset.QuadPart;

	date = Jan1st1970 + (LONGLONG)t * (LONGLONG)10000000
				+ (LONGLONG)usec * 10;

	ft->dwLowDateTime = liOffset.LowPart;
	ft->dwHighDateTime = liOffset.HighPart;
}

#define VERSION_REQUIRED	0x101
#define TIMEOUT_SEC			600

static char RemoteBuffer[20480];
static int buffirst = 0, buflast = 0;

#define READ_EOF	0
#define READ_ERR	-1
#define READ_OK		1

static int ReadSocket(SOCKET sock) {
	struct timeval timeout;
	int result;

	fd_set readfds, writefds;
	FD_ZERO(&readfds);
	FD_ZERO(&writefds);
	FD_SET(sock, &readfds);

	timeout.tv_sec = TIMEOUT_SEC;
	timeout.tv_usec = 0;

	result = select((int)sock, &readfds, NULL, NULL, &timeout);
	if (result < 0)
		return READ_ERR;

	if (FD_ISSET(sock, &readfds)) {
		result = recv(sock, RemoteBuffer + buflast, sizeof RemoteBuffer - buflast, 0);
		if (result == 0)
			return READ_EOF;
		else if (result < 0)
			return READ_ERR;
		buflast += result;
		return READ_OK;
	} else return READ_ERR;
}


static int socketget(LPBYTE buff, int size, SOCKET sock) {
	int n = 0;
	int result;
	do {
		while (buffirst < buflast) {
			buff[n++] = RemoteBuffer[buffirst++];
			if (n >= size) return n;
		}
		buffirst = buflast = 0;
		result = ReadSocket(sock);
	} while (result == READ_OK);
	return (result == READ_ERR) ? -1 : n;
}



static LPSTR socketgets(LPSTR buff, int size, SOCKET sock) {
	int n = 0;
	int result;
	do {
		while (buffirst < buflast) {
			if ((buff[n++] = RemoteBuffer[buffirst++]) == '\n') {
				if (n < size) buff[n] = '\0';
					return buff;
			}
			if (n >= size) return buff;
		}
		buffirst = buflast = 0;
		result = ReadSocket(sock);
	} while (result == READ_OK);
	return NULL;
}


static int socketputs(LPCSTR buff, SOCKET sock) {
	struct timeval timeout;
	int result, size = strlen(buff), len = 0;

	for (;;) {
		fd_set writefds;
		FD_ZERO(&writefds);
		FD_SET(sock, &writefds);

		timeout.tv_sec = TIMEOUT_SEC;
		timeout.tv_usec = 0;

		result = select((int)sock, NULL, &writefds, NULL, &timeout);
		if (result < 0)
			return result;

		if (FD_ISSET(sock, &writefds)) {
			int sent = send(sock, buff, size, 0);
			len += sent;
			size -= sent;
			buff += sent;
			if (size == 0)
				return len;
		} else return len;
	}
}



static SOCKET ConnectSocket(LPSTR machine, int port) {
	buffirst = buflast = 0;

	SOCKET sockfd;

	struct in_addr ip;

	if ((ip.s_addr = inet_addr(machine)) == -1) {	// IS IT IN DOT FMT
		struct hostent *ho = gethostbyname((*machine == '\0') ? "localhost" : machine);

		if (ho == NULL) {
			fprintf(stderr, "Unknown host: %s\n", machine);
			return INVALID_SOCKET;
		}


		/*
		 * IF WE MAKE IT HERE, WE HAVE TO COPY THE HOSTNAME
		 * INTO THE ADDRESS STRUCTURE
		 */
		memcpy(&ip.s_addr, ho->h_addr, ho->h_length);
	}

	struct sockaddr_in serv_addr;
	ZeroMemory(&serv_addr, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = ip.s_addr;
	serv_addr.sin_port = htons(port);

	/*
	 * THIS IS A LITTLE NASTY
	 * IF THE SERVER'S NOT UP, THIS WILL WAIT A LONG TIME BEFORE
	 * IT TIMES OUT.  SO HANDLE THAT HERE... IT GETS 3 SECONDS TO ANSWER
	 */

	/* OPEN SOCKET */
	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET) {
		fprintf(stderr, "Can't open stream socket\n");
		return INVALID_SOCKET;
	} else if (connect(sockfd, (struct sockaddr *) &serv_addr,
                     sizeof(serv_addr)) == SOCKET_ERROR) {
		closesocket(sockfd);
		return INVALID_SOCKET;
	} else return sockfd;
}


LPSTR getURL(char *host, int port, char *doc, char *proxyHost = NULL, int proxyPort = 0) {
	WSADATA wsaData;
	WSAStartup(VERSION_REQUIRED, &wsaData);

	SOCKET sock;

	int len;
	char buff[20480];
	if (proxyHost == NULL) {
		sock = ConnectSocket(host, port);
		if (sock == INVALID_SOCKET) {
			fprintf(stderr, "Can not connect to %s, port %d\n", host, port);
			WSACleanup();
			return NULL;
		}

		len = socketputs("GET ", sock);
		len = socketputs(doc, sock);
		len = socketputs(" HTTP/1.0\r\n", sock);
		if (log_file != NULL) {
			//fprintf(log_file, "http://%s:%d/%s\n", host, port, doc);
			fputs("GET ", log_file);
			fputs(doc, log_file);
			fputs(" HTTP/1.0\r\n", log_file);
			fflush(log_file);
		}
	} else {
		sock = ConnectSocket(proxyHost, proxyPort);
		if (sock == INVALID_SOCKET) {
			fprintf(stderr, "Can not connect to %s, port %d\n", proxyHost, proxyPort);
			WSACleanup();
			return NULL;
		}

		len = socketputs("GET http://", sock);
		len = socketputs(host, sock);
		len = socketputs(doc, sock);
		len = socketputs(" HTTP/1.0\r\n", sock);
	}

	/*
	if (proxyHost != NULL)
		len = socketputs("Proxy-", sock);
	len = socketputs("Connection: Keep-Alive\r\n", sock);
	len = socketputs("Keep-Alive: 300\r\n", sock);
	*/

	sprintf(buff, "Host: %s:%d\r\n", host, port);
	len = socketputs(buff, sock);

	//len = socketputs("User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.3) Gecko/20030312\r\n", sock);

	len = socketputs("\r\n", sock);
	if (log_file != NULL) {
		fputs("\r\n", log_file);
		fflush(log_file);
	}

	LPSTR result = NULL;
	int maxLen = 65536;
	BOOL redirect = FALSE;
	if (socketgets(buff, sizeof buff, sock)) {
		if (log_file != NULL) {
			fputs(buff, log_file);
			fflush(log_file);
		}
		int major, minor, response;
		int n = sscanf(buff, "HTTP/%d.%d %d ", &major, &minor, &response);
		if ((response/100) == 3) {
			redirect = TRUE;
		} else if ((response/100) != 2) {
			closesocket(sock);
			WSACleanup();
			return NULL;
		}
	} else {
		closesocket(sock);
		WSACleanup();
		return NULL;
	}

	char *redirectLocation = NULL;
	while(socketgets(buff, sizeof buff, sock)) {
		if (log_file != NULL) {
			fputs(buff, log_file);
			fflush(log_file);
		}
		if ((*buff == '\r') || (*buff == '\n')) {
			result = (LPSTR)malloc(maxLen);
			break;
		}
		if (redirect && (strnicmp(buff, "Location: ", 10) == 0)) {
			char *p = buff + 10;
			while (isspace(*p)) {
				++p;
			}
			char *q = p;
			while (*q && (*q != '\n') && (*q != '\r')) {
				++q;
			}
			*q = '\0';
			redirectLocation = strdup (p);
		}
	}

	if (redirectLocation) {
		free(result);
		result = NULL;
		if (strncmp(redirectLocation, "http://", 7) == 0) {
			char *p = redirectLocation + 7;
			char *q = strchr(p, '/');
			if (q != NULL) {
				*q = '\0';
				char *pp = strchr(p, ':');
				int port;
				if (pp != NULL) {
					*pp++ = '\0';
					port = atol(pp);
				} else {
					port = 80;
				}
				char *hostName = strdup(p);
				*q = '/';
				char *url = strdup(q);
				result = getURL(hostName, port, url);
				free(url);
				free(hostName);
			}
		}
		free(redirectLocation);

		return result;
	}

	if (result == NULL)
	return NULL;

	*result = '\0';

	while(socketgets(buff, sizeof buff, sock)) {
		int need = strlen(result) + strlen(buff);
		if (need >= maxLen) {
			maxLen = need + 20480;
			result = (LPSTR)realloc(result, maxLen);
		}
		strcat(result, buff);
	}


	closesocket(sock);

	WSACleanup();

#ifdef _DEBUG
	FILE *fp = fopen("c:\\temp.txt", "w");
	fputs(result, fp);
	fclose(fp);
#endif

	return result;
}



BOOL getURLBinary(HANDLE fp, char *host, int port, char *doc,
				  char *proxyHost = NULL, int proxyPort = 0, char *ref = NULL) {
	WSADATA wsaData;
	WSAStartup(VERSION_REQUIRED, &wsaData);

	SOCKET sock;

	int len;

	char buff[20480];
	if (proxyHost == NULL) {
		sock = ConnectSocket(host, port);
		if (sock == INVALID_SOCKET) {
			fprintf(stderr, "Can not connect to %s, port %d\n", host, port);
			WSACleanup();
			return FALSE;
		}

		len = socketputs("GET ", sock);
		len = socketputs(doc, sock);
		len = socketputs(" HTTP/1.0\r\n", sock);
		if (log_file != NULL) {
			fprintf(log_file, "http://%s:%d/%s\n", host, port, doc);
			fflush(log_file);
		}
	} else {
		sock = ConnectSocket(proxyHost, proxyPort);
		if (sock == INVALID_SOCKET) {
			fprintf(stderr, "Can not connect to %s, port %d\n", proxyHost, proxyPort);
			WSACleanup();
			return FALSE;
		}

		len = socketputs("GET http://", sock);
		len = socketputs(host, sock);
		len = socketputs(doc, sock);
		len = socketputs(" HTTP/1.0\r\n", sock);
	}

	if (proxyHost != NULL)
		len = socketputs("Proxy-", sock);
	len = socketputs("Connection: Keep-Alive\r\n", sock);

	/**/
	sprintf(buff, "Host: %s:%d\r\n", host, port);
	len = socketputs(buff, sock);
	/**/

	len = socketputs("User-Agent: Mozilla/4.6 [en-gb] (WinNT; U)\r\n", sock);

	if (ref != NULL) {
		len = socketputs("Referer: ", sock);
		len = socketputs(ref, sock);
		len = socketputs("\r\n", sock);
	}


	len = socketputs("\r\n", sock);

	long contentLength = -1;
	BOOL ok = FALSE;
	if (socketgets(buff, sizeof buff, sock)) {
		int major, minor, response;
		int n = sscanf(buff, "HTTP/%d.%d %d ", &major, &minor, &response);
		if ((response/100) != 2) {
			closesocket(sock);
			WSACleanup();
			return NULL;
		}
	} else {
		closesocket(sock);
		WSACleanup();
		return NULL;
	}
	while(socketgets(buff, sizeof buff, sock)) {
		if (strnicmp(buff, "Last-Modified: ", 15) == 0) {
			FILETIME ft;
			time_tToFileTime(&ft, parsedate(buff + 15), 0);

			BOOL b = SetFileTime(fp, &ft, &ft, &ft);
		}
		if ((*buff == '\r') || (*buff == '\n'))
			break;
		if (_strnicmp(buff, CONTENT_LENGTH, sizeof CONTENT_LENGTH - 1) == 0) {
			contentLength = atol(buff + sizeof CONTENT_LENGTH -1);
			ok = TRUE;
			continue;
		}
	}

	int n;
	int need;
	if ((contentLength < 0) || (sizeof buff < contentLength)) {
		need = sizeof buff;
	} else {
		need = contentLength;
	}
	while ((n = socketget((LPBYTE)buff, need, sock)) > 0) {
		DWORD NumberOfBytesWritten;
		WriteFile(fp, buff, n, &NumberOfBytesWritten, NULL);
		if (contentLength > 0) {
			contentLength -= n;
			if (contentLength <= 0) {
				ok = TRUE;
				break;
			}
			if (sizeof buff < contentLength)
				need = sizeof buff;
			else
				need = contentLength;
		} else {
			need = sizeof buff;
		}
	}

	closesocket(sock);

	WSACleanup();

	return (n<0) ? FALSE : ok;
}



static DWORD GetFileSize(LPCSTR szFileName) {
	HANDLE hInput = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ,
	                           NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hInput == INVALID_HANDLE_VALUE) return -1;

	DWORD FileSizeHigh;
	DWORD dw = GetFileSize(hInput, &FileSizeHigh);

	CloseHandle(hInput);

	return dw;
}





static LPTSTR LastErrorString(DWORD err = -1) {
	if (err == -1) err = GetLastError();

	static TCHAR szMsgBuf[256];
	LPTSTR lpMsgBuf;
	DWORD result =
		FormatMessage(
				FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
				NULL,
				err,
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL
		);
	if (result != 0) {
		lstrcpy (szMsgBuf, lpMsgBuf);
		// Free the buffer
		LocalFree( lpMsgBuf );
	}
	else {
		fprintf(log_file, TEXT("Error#%d"), err);
	}
	int n = strlen(szMsgBuf);
	while (--n >= 0) {
		if ((szMsgBuf[n] == '\r') || (szMsgBuf[n] == '\n')) {
			szMsgBuf[n] = '\0';
		}
	}
	return szMsgBuf;
}

char *post(char *host, const short port, LPCSTR doc, const int argc, char **argn, char **argv, char *proxyHost = NULL, int proxyPort = 0, char *ref = NULL) {
	WSADATA wsaData;
	WSAStartup(VERSION_REQUIRED, &wsaData);

	int len;
	SOCKET sock;
	if (proxyHost == NULL) {
		sock = ConnectSocket(host, port);
		if (sock == INVALID_SOCKET) {
			fprintf(stderr, "Can not connect to %s, port %d\n", host, port);
			WSACleanup();
			return FALSE;
		}

		len = socketputs("POST ", sock);
		len = socketputs(doc, sock);
		len = socketputs(" HTTP/1.1\r\n", sock);
		if (log_file != NULL) {
			fprintf(log_file, "http://%s:%d/%s\n", host, port, doc);
			fflush(log_file);
		}
	} else {
		sock = ConnectSocket(proxyHost, proxyPort);
		if (sock == INVALID_SOCKET) {
			fprintf(stderr, "Can not connect to %s, port %d\n", proxyHost, proxyPort);
			WSACleanup();
			return FALSE;
		}

		len = socketputs("POST http://", sock);
		len = socketputs(host, sock);
		len = socketputs(doc, sock);
		len = socketputs(" HTTP/1.1\r\n", sock);
	}

	if (proxyHost != NULL)
		len = socketputs("Proxy-", sock);
	len = socketputs("Connection: Keep-Alive\r\n", sock);
	len = socketputs("Keep-Alive: 300\r\n", sock);


	/**/
	char buff[2048];
	sprintf(buff, "Host: %s:%d\r\n", host, port);
	len = socketputs(buff, sock);
	/**/

	len = socketputs("User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.3) Gecko/20030312\r\n", sock);

	if (ref != NULL) {
		len = socketputs("Referer: ", sock);
		len = socketputs(ref, sock);
		len = socketputs("\r\n", sock);
	}

	int maxLen = 0;
	for (int n = 0; n < argc; ++n) {
		maxLen += strlen(argn[n]) + 1 + 3*strlen(argv[n]);
	}
	char *tmpBuff = new char[maxLen];
	char *p = tmpBuff;
	for (n = 0; n < argc; ) {
		maxLen += strlen(argn[n]) + 2 + 3*strlen(argv[n]);
		strcpy(p, argn[n]);
		p += strlen(p);
		*p++ = '=';
		char *q = argv[n];
		while (*q != '\0') {
			if (isalnum(*q)) {
				*p++ = *q++;
			} else if (*q == ' ') {
				*p++ = '+';
				++q;
			} else {
				sprintf(p, "%%%02X", *q++);
				p += 3;
			}
		}
		if (++n < argc) {
			*p++ = '&';
		}
		*p = '\0';
	}
	len = socketputs("Content-Type: application/x-www-form-urlencoded\r\n", sock);
	sprintf(buff, "Content-Length: %d\r\n", strlen(tmpBuff));
	len = socketputs(buff, sock);
	len = socketputs("\r\n", sock);
	len = socketputs(tmpBuff, sock);

	delete tmpBuff;


	LPSTR result = NULL;
	maxLen = 65536;
	BOOL redirect = FALSE;
	if (socketgets(buff, sizeof buff, sock)) {
		if (log_file != NULL) {
			fputs(buff, log_file);
			fflush(log_file);
		}
		int major, minor, response;
		int n = sscanf(buff, "HTTP/%d.%d %d ", &major, &minor, &response);
		if ((response/100) == 3) {
			redirect = TRUE;
		} else if ((response/100) != 2) {
			closesocket(sock);
			WSACleanup();
			return NULL;
		}
	} else {
		closesocket(sock);
		WSACleanup();
		return NULL;
	}

	char *redirectLocation = NULL;
	while(socketgets(buff, sizeof buff, sock)) {
		if (log_file != NULL) {
			fputs(buff, log_file);
			fflush(log_file);
		}
		if ((*buff == '\r') || (*buff == '\n')) {
			result = (LPSTR)malloc(maxLen);
			break;
		}
		if (redirect && (strnicmp(buff, "Location: ", 10) == 0)) {
			char *p = buff + 10;
			while (isspace(*p)) {
				++p;
			}
			char *q = p;
			while (*q && (*q != '\n') && (*q != '\r')) {
				++q;
			}
			*q = '\0';
			redirectLocation = strdup (p);
		}
	}

	if (redirectLocation) {
		free(result);
		result = NULL;
		if (strncmp(redirectLocation, "http://", 7) == 0) {
			char *p = redirectLocation + 7;
			char *q = strchr(p, '/');
			if (q != NULL) {
				*q = '\0';
				char *pp = strchr(p, ':');
				int port;
				if (pp != NULL) {
					*pp++ = '\0';
					port = atol(pp);
				} else {
					port = 80;
				}
				char *host = strdup(p);
				*q = '/';
				char *url = strdup(q);
				result = getURL(host, port, url);
				free(url);
				free(host);
			}
		}
		free(redirectLocation);

		return result;
	}

	if (result == NULL) {
		return NULL;
	}

	*result = '\0';

	while(socketgets(buff, sizeof buff, sock)) {
		int need = strlen(result) + strlen(buff);
		if (need >= maxLen) {
			maxLen = need + 20480;
			result = (LPSTR)realloc(result, maxLen);
		}
		strcat(result, buff);
	}


	closesocket(sock);

	WSACleanup();

#ifdef _DEBUG
	FILE *fp = fopen("c:\\temp.txt", "w");
	fputs(result, fp);
	fclose(fp);
#endif

	return result;
}




#define BOARD_SIZE		10
#define PLOCA			PLOCA10
#define BROJ_FIGURA		20

#define SQUARES			(BOARD_SIZE*BOARD_SIZE)
#define BLACK_SQUARES	(SQUARES/2)
#define WIDTH			2
#define SPACE			3
#define USED_WIDTH		(2*(SPACE+WIDTH)+BOARD_SIZE*SQUARE_WIDTH)
#define BITMAP_WIDTH	(((USED_WIDTH+3)/4)*4)
#define EMPTY_WIDTH		(BITMAP_WIDTH-USED_WIDTH)
#define EMPTY_LEFT		(EMPTY_WIDTH/2)
#define EMPTY_RIGHT		(EMPTY_WIDTH-EMPTY_LEFT)
#define BITMAP_HEIGHT	(USED_WIDTH)
#define BITMAP_SIZE		(BITMAP_WIDTH*BITMAP_HEIGHT)

#define	COL_WHITE		0xff
#define COL_BLACK		0x00

#define X_OFFSET		12
#define Y_OFFSET		12

static HINSTANCE hInstance;
static HBITMAP hIcon[5];

static char *draw = "ProposeDraw";
static char *drawText = "Propose draw";


static TCHAR DlgTitle[650];

void posaljiPotez(char *potez, char *komentar, char *);

game *currentGame = NULL;


static void crtajPoziciju(HWND hwnd, game *g) {
	int m = (okreni) ? 150 : 101;
	for (int n = 1; n <= BLACK_SQUARES; ++n) {
		SendDlgItemMessage (hwnd, m, STM_SETIMAGE,
					(WPARAM)IMAGE_BITMAP,
					(LPARAM)hIcon[g->polje(n) + 2]);
		if (okreni)
			--m;
		else
			++m;
	}
}



static void pdnOnCommand(HWND hwnd, int id, HWND, UINT)
{
	if (id == IDCANCEL) {
		EndDialog (hwnd, IDCANCEL);
	} else if (id == IDOK) {
		FILE *pdn = fopen("c:\\test.pdn", "a");
		char tmp[2048];
		UINT ui = GetDlgItemText(hwnd, IDC_EVENT, tmp, sizeof tmp);
		fprintf(pdn, "[Event \"%s\"]\n", tmp);
		ui = GetDlgItemText(hwnd, IDC_SITE, tmp, sizeof tmp);
		fprintf(pdn, "[Site \"%s\"]\n", tmp);
		ui = GetDlgItemText(hwnd, IDC_DATE, tmp, sizeof tmp);
		fprintf(pdn, "[Date\"%s\"]\n", tmp);
		ui = GetDlgItemText(hwnd, IDC_ROUND, tmp, sizeof tmp);
		fprintf(pdn, "[Round \"%s\"]\n", tmp);
		ui = GetDlgItemText(hwnd, IDC_WHITE, tmp, sizeof tmp);
		fprintf(pdn, "[White \"%s\"]\n", tmp);
		ui = GetDlgItemText(hwnd, IDC_BLACK, tmp, sizeof tmp);
		fprintf(pdn, "[Black \"%s\"]\n", tmp);
		ui = GetDlgItemText(hwnd, IDC_RESULT, tmp, sizeof tmp);
		fprintf(pdn, "[Result \"%s\"]\n", tmp);
		/*
		ui = GetDlgItemText(hwnd, IDC_SETUP, tmp, sizeof tmp);
		fprintf(pdn, "[SetUp \"%s\"]\n", tmp);
		*/
		putc('\n', pdn);
		int n = 0;
		while (n < currentGame->broj) {
			fprintf(pdn, "%d. %s ", (n/2)+1, currentGame->listaPoteza[n]);
			if (++n < currentGame->broj) {
				fprintf(pdn, "%s", currentGame->listaPoteza[n]);
				++n;
				if ((n % 10) == 0)
					putc('\n', pdn);
				else
					putc(' ', pdn);
			}
		}
		fputs("\n\n\n", pdn);
		fclose(pdn);

		EndDialog (hwnd, IDOK);
	}
}

static BOOL pdnOnInitDialog(HWND hwnd, HWND, LPARAM p)
{
	game *g = (game *)p;

	SetDlgItemText(hwnd, IDC_WHITE, g->bijeli);
	SetDlgItemText(hwnd, IDC_BLACK, g->crni);
	SetDlgItemText(hwnd, IDC_SETUP, "1");


	return TRUE;
}

static BOOL CALLBACK PdnDlgProc(
    HWND hwndDlg,
        UINT  uMsg,
            WPARAM  wParam,
                LPARAM  lParam)
{
    switch (uMsg) {
        HANDLE_MSG(hwndDlg, WM_INITDIALOG, pdnOnInitDialog);
        HANDLE_MSG(hwndDlg, WM_COMMAND,    pdnOnCommand);
    }
    return FALSE;
}



static void OnCommand(HWND hwnd, int id, HWND, UINT)
{
	if (id == IDCANCEL) {
		EndDialog (hwnd, IDCANCEL);
	} else if (id == IDOK) {
		HWND hwndCtl = GetDlgItem(hwnd, IDC_POTEZI);
		int index = ListBox_GetCurSel(hwndCtl);
		char *potez;
		int len;
		if (index < 0) {
			potez = (char *)malloc(1);
			len = 0;
		} else {
			len = ListBox_GetTextLen(hwndCtl, index);
			potez = new char[len+1];
		}
		potez[len] = '\0';
		int x = ListBox_GetText(hwndCtl, index, potez);
		HWND hwndEdit = GetDlgItem(hwnd, IDC_KOMENTAR);
		len = Edit_GetTextLength(hwndEdit);
		char *komentar = new char[len+1];
		Edit_GetText(hwndEdit, komentar, len+1);
		komentar[len] = '\0';

		hwndEdit = GetDlgItem(hwnd, IDC_PASSWORD);
		len = Edit_GetTextLength(hwndEdit);
		char *password = new char[len+1];
		Edit_GetText(hwndEdit, password, len+1);
		password[len] = '\0';

		if (IsDlgButtonChecked(hwnd, IDC_NONE))
			command = "";
		else if (IsDlgButtonChecked(hwnd, IDC_UNDO))
			command = "Undo";
		else if (IsDlgButtonChecked(hwnd, IDC_PROPOSEDRAW))
			command = draw;
		else if (IsDlgButtonChecked(hwnd, IDC_RESIGN))
			command = "Resign";

		posaljiPotez(potez, komentar, password);
		delete potez;
		delete komentar;
		delete password;
		EndDialog (hwnd, IDOK);
	} else if ((id >= 101) && (id <= 150)) {
		int polje = (okreni) ? (151 - id) : (id - 100);
		int count = currentGame->moguci_potezi();
		HWND hwndCtl = GetDlgItem(hwnd, IDC_POTEZI);
		int index = ListBox_GetCount(hwndCtl);
		while (index >= 0) {
			char tmp[32];
			ListBox_GetText(hwndCtl, index, tmp);
			int from, to, ch;
			int x = sscanf(tmp, "%d%c%d", &from, &ch, &to);
			if ((from != polje) && (to != polje)) {
				ListBox_DeleteString(hwndCtl, index);
			}
			--index;
		}
		if (ListBox_GetCount(hwndCtl) == 0) {
			for (int n = 0; n < count; ++n) {
				if ((currentGame->POLJE[n].sa == (polje-1)) ||
					(currentGame->POLJE[n].na == (polje-1))) {
					char *m = currentGame->fullDisplay(n);
					/*
					char *p = strchr(m, ':');
					if (p != NULL) *p = 'x';
					*/
					char *p;
					while ((p = strchr(m, ':')) != NULL) {
						*p = 'x';
					}
					ListBox_AddString(hwndCtl, m);
				}
			}
			
			if (ListBox_GetCount(hwndCtl) == 0) {
				for (int n = 0; n < count; ++n) {
					char *m = currentGame->fullDisplay(n);
					/*
					char *p = strchr(m, ':');
					if (p != NULL) *p = 'x';
					*/
					char *p;
					while ((p = strchr(m, ':')) != NULL) {
						*p = 'x';
					}
					ListBox_AddString(hwndCtl, m);
				}
			}
		}
		if (ListBox_GetCount(hwndCtl) == 1) {
			ListBox_SetCurSel(hwndCtl, 0);
		}
	} else if (id == IDC_OKRENI) {
		okreni = !okreni;
		crtajPoziciju(hwnd, currentGame);
	} else if (id == IDC_PDNSAVE) {
		DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_PDNSAVE),
					hwnd, (DLGPROC)PdnDlgProc,
					(LPARAM)currentGame);
	}
}



static BOOL OnInitDialog(HWND hwnd, HWND, LPARAM p)
{
	SetWindowText(hwnd, DlgTitle);
	game *g = (game *)p;
	currentGame = g;
	crtajPoziciju(hwnd, currentGame = g);

	int count = g->moguci_potezi();
	HWND hwndCtl = GetDlgItem(hwnd, IDC_POTEZI);
	for (int n = 0; n < count; ++n) {
		char *m = g->fullDisplay(n);
		char *p;
		while ((p = strchr(m, ':')) != NULL) {
			*p = 'x';
		}
		ListBox_AddString(hwndCtl, m);
	}
	if (ListBox_GetCount(hwndCtl) == 1) {
		ListBox_SetCurSel(hwndCtl, 0);
	}
	SetDlgItemText(hwnd, IDC_BIJELI, g->bijeli);
	SetDlgItemText(hwnd, IDC_CRNI, g->crni);
	SetDlgItemText(hwnd, IDC_LAST_COMMENT, g->lastComment);
	if (endMessage != NULL) {
		SetDlgItemText(hwnd, IDC_REZULTAT, "Rezultat");
		SetDlgItemText(hwnd, IDCANCEL, "Zatvori");
		SetDlgItemText(hwnd, IDC_LAST_MOVE, endMessage);

		ShowWindow(GetDlgItem(hwnd, IDC_POTEZI), SW_HIDE);
		ShowWindow(GetDlgItem(hwnd, IDC_KOMENTAR), SW_HIDE);
		ShowWindow(GetDlgItem(hwnd, IDC_PASSWORD), SW_HIDE);
		ShowWindow(GetDlgItem(hwnd, IDC_NONE), SW_HIDE);
		ShowWindow(GetDlgItem(hwnd, IDC_UNDO), SW_HIDE);
		ShowWindow(GetDlgItem(hwnd, IDC_PROPOSEDRAW), SW_HIDE);
		ShowWindow(GetDlgItem(hwnd, IDC_RESIGN), SW_HIDE);
		ShowWindow(GetDlgItem(hwnd, IDC_CMDGROUP), SW_HIDE);
		ShowWindow(GetDlgItem(hwnd, IDOK), SW_HIDE);
	} else {
		char posljednjiPotez[128];
		if (g->broj == 0) {
			*posljednjiPotez = '\0';
		} else {
			sprintf(posljednjiPotez, "%d.%s%s", (g->broj+1)/2, ((g->broj % 2) == 0) ? " ... " : "",
												g->listaPoteza[g->broj-1]);
		}
		SetDlgItemText(hwnd, IDC_LAST_MOVE, posljednjiPotez);
		SetDlgItemText(hwnd, IDC_PARTIJA, partija);

		SetDlgItemText(hwnd, IDC_PROPOSEDRAW, drawText);
		CheckDlgButton(hwnd, IDC_NONE, TRUE);
	}

	return TRUE;
}

static BOOL CALLBACK PlocaDlgProc(
    HWND hwndDlg,
        UINT  uMsg,
            WPARAM  wParam,
                LPARAM  lParam)
{
    switch (uMsg) {
        HANDLE_MSG(hwndDlg, WM_INITDIALOG, OnInitDialog);
        HANDLE_MSG(hwndDlg, WM_COMMAND,    OnCommand);
    }
    return FALSE;
}

static int DoDlgPloca(HWND hWndParent, game *g)
{
#ifdef MY_DEBUG
	return DialogBoxParam(hInstance, "PLOCA11",
				hWndParent, (DLGPROC)WndProc,
					(LPARAM)g);

#else
	return DialogBoxParam(hInstance, MAKEINTRESOURCE(PLOCA),
				hWndParent, (DLGPROC)PlocaDlgProc,
					(LPARAM)g);
#endif
}

static char *getPlayer(char* &tmp) {
	static const char *writeContact = "writeContact(";
	char *pp = strstr(tmp, writeContact);
	if (pp != NULL) {
		pp += strlen(writeContact);
		while (*pp && (*pp != '"')) {
			++pp;
		}
		char domena[128], *d = domena;
		for (;;) {
			++pp;
			if ((pp == NULL) || (*pp == '"'))
				break;
			int ch;
			int nn = sscanf(pp, "&#%d;", &ch);
			if (nn == 1)
				*d++ = ch;
			char *qq = strchr(pp, ';');
			pp = qq;
		}
		*d = '\0';
		pp = strchr(pp+1, '"');
		++pp;
		char ime[128];
		d = ime;
		while (*pp && (*pp != '"'))
			*d++ = *pp++;
		*d = '\0';
		pp = strchr(pp+1, '"');
		char user[128];
		d = user;
		for (;;) {
			++pp;
			if ((pp == NULL) || (*pp == '"'))
				break;
			int ch;
			int nn = sscanf(pp, "&#%d;", &ch);
			if (nn == 1)
				*d++ = ch;
			char *qq = strchr(pp, ';');
			pp = qq;
		}
		*d = '\0';
		char *result = (char *)malloc(strlen(ime)+strlen(user)+strlen(domena)+5);
		sprintf(result, "%s <%s@%s>", ime, user, domena);
		tmp = pp;
		return result;
	} else {
		return NULL;
	}
}

	
static char *getParamValue(char *p, char *name) {
	char tmp[60000];
	sprintf(tmp, "<param name=\"%s\"", name);
	char *q = strstr(p, tmp);
	if (q == NULL)
		return NULL;
	q += strlen(tmp);
	while (*q != '>') {
		if (strncmp(q, "value", 5) == 0)
			break;
		++q;
	}
	if (*q == '>')
		return NULL;
	q += 5;
	while ((*q != '>') && (*q != '"'))
		++q;
	if (*q == '>')
		return NULL;
	++q;
	char *t = tmp;
	while ((*q != '>') && (*q != '"'))
		*t++ = *q++;
	if (*q == '>')
		return NULL;
	*t++ = '\0';

	return strdup(tmp);
}


static char *junkNotation[] = {
	"a6",	"b7",	"c8",	"d9",	"e10",
	"a5",	"b6",	"c7",	"d8",	"e9",
	"b5",	"c6",	"d7",	"e8",	"f9",
	"b4",	"c5",	"d6",	"e7",	"f8",
	"c4",	"d5",	"e6",	"f7",	"g8",
	"c3",	"d4",	"e5",	"f6",	"g7",
	"d3",	"e4",	"f5",	"g6",	"h7",
	"d2",	"e3",	"f4",	"g5",	"h6",
	"e2",	"f3",	"g4",	"h5",	"i6",
	"e1",	"f2",	"g3",	"h4",	"i5",
};

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR szCmdLine, int) {
	::hInstance = hInstance;
	HWND hwnd = GetDesktopWindow();

	sprintf(GAME_URL, URL_FMT, szCmdLine);

	char *tmp;

#ifdef _DEBUG
	log_file = fopen("c:\\dama.txt", "a");
#endif

#if !defined(_DEBUG) || 1
	tmp = getURL(HOST, 80, GAME_URL);
#else
	char *FILE_NAME = "c:\\dama.html";
	DWORD dw = GetFileSize(FILE_NAME);
	if ((int)dw > 0) {
		tmp = (char *)malloc(dw+1);
		FILE *fp = fopen(FILE_NAME, "rb");
		fread(tmp, 1, dw, fp);
		tmp[dw] = '\0';
		fclose(fp);
	} else {
		tmp = NULL;
	}

#endif

#ifdef _DEBUG
	fclose(log_file);
#endif

	if (tmp == NULL) {
		MessageBox(NULL, "Ne mogu se spojiti na " HOST, NULL, MB_OK);
		_CrtDumpMemoryLeaks();
		return -1;
	}


	char *p = strstr(tmp, "<option value=\"AcceptDraw\">Accept draw");
	if (p != NULL) {
		draw = "AcceptDraw";
		drawText = "Accept draw";
	}

	char *pp = strstr(tmp, "<form "), *qq;
	if (pp != NULL) {
		pp = strstr(pp, "action=");
		if (pp != NULL) {
			pp += 7;
			while (*pp && (*pp != '"')) ++pp;
			qq = ++pp;
			while (*qq && (*qq != '"')) ++qq;
			*qq = '\0';
			action = strdup(pp);
			*qq++ = '"';
		}
	} else {
		qq = tmp;
	}

	pp = strstr(qq, "playsWhite");
	if (pp != NULL) {
		pp = strstr(pp, "value=");
		if (pp != NULL) {
			pp += 6;
			while (*pp && !isdigit(*pp)) ++pp;
			char *qq = pp;
			while (isdigit(*qq)) ++qq;
			char ch = *qq;
			*qq = '\0';
			playsWhite = strdup(pp);
			*qq++ = ch;
		}
	}

	pp = strstr(qq, "playsBlack");
	if (pp != NULL) {
		pp = strstr(pp, "value=");
		if (pp != NULL) {
			pp += 6;
			while (*pp && !isdigit(*pp)) ++pp;
			char *qq = pp;
			while (isdigit(*qq)) ++qq;
			char ch = *qq;
			*qq = '\0';
			playsBlack = strdup(pp);
			*qq++ = ch;
		}
	}

	char *txt = tmp;
	char *bijeli = getPlayer(txt);
	char *crni = getPlayer(txt);

	static const char *PlyToPlay = "<!--PlyToPlay=";
	p = strstr(tmp, PlyToPlay);
	if (p != NULL) {
		hIcon[0] = LoadBitmap(hInstance, MAKEINTRESOURCE(CD));
		hIcon[1] = LoadBitmap(hInstance, MAKEINTRESOURCE(CO));
		hIcon[2] = LoadBitmap(hInstance, MAKEINTRESOURCE(PR));
		hIcon[3] = LoadBitmap(hInstance, MAKEINTRESOURCE(BO));
		hIcon[4] = LoadBitmap(hInstance, MAKEINTRESOURCE(BD));

		game g(bijeli, crni);
		p += strlen(PlyToPlay);
		endMessage = getParamValue(p, "EndMessage");
		char *finalComment = getParamValue(p, "FinalComment");
		int nn = atol(p);
		char pname[128];
		g.lastComment = NULL;
		partija = (char *)malloc(20481);
		*partija = '\0';
		int psize = 20480;
		for (int n = 0; n < nn-1; ++n) {
			char *saved;
			int potez = (n/2)+1;
			if ((n % 2) == 0) {
				char szTmp[8];
				sprintf(szTmp, "%d.", potez);
				if ((int)(strlen(partija) + strlen(szTmp)) >= psize) {
					psize *= 2;
					partija = (char *)realloc(partija, psize + 1);
				}
				strcat(partija, szTmp);
				sprintf(pname, "White_%d", potez);
			} else {
				sprintf(pname, "Black_%d", potez);
			}
			char *tmp = getParamValue(p, pname);
			if (tmp == NULL)
				break;
			if ((int)(strlen(partija) + strlen(tmp) + 1) >= psize) {
				psize *= 2;
				partija = (char *)realloc(partija, psize + 1);
			}
			saved = partija + strlen(partija);
			strcat(partija, tmp);
			strcat(partija, " ");
			int over[20], no = 0;
			char *pp = tmp, ch0;
			int from = -1, ch, to = -1;
#if defined(_DEBUG) || 1
			for (no = 0; *pp != '\0'; ++no) {
				int nn = sizeof junkNotation/sizeof junkNotation[0];
				while (--nn >= 0) {
					if (strncmp(pp, junkNotation[nn], strlen(junkNotation[nn])) == 0)
						break;
				}
				if (nn < 0) 
					break;
				over[no] = nn + 1;
				pp += strlen(junkNotation[nn]);
				if (*pp) ch0 = *pp++;
			}

			/*
			from = sizeof junkNotation/sizeof junkNotation[0]; 
			while (--from >= 0) {
				if (strncmp(pp, junkNotation[from], strlen(junkNotation[from])) == 0)
					break;
			}
			if (from >= 0) {
				pp += strlen(junkNotation[from]);
				ch = *pp++;
				to = sizeof junkNotation/sizeof junkNotation[0]; 
				while (--to >= 0) {
					if (strncmp(pp, junkNotation[to], strlen(junkNotation[to])) == 0)
						break;
				}
				if (to >= 0) {
					pp += strlen(junkNotation[to]);
					if ((int)(strlen(partija) + 6) >= psize) {
						psize *= 2;
						partija = (char *)realloc(partija, psize + 1);
					}
					++from;		++to;
					sprintf(saved, "%d%c%d ", from, ch, to);
				}
			}
			*/
#endif
			char *move;
			/*
			if ((from < 0) || (to < 0)) {
				no = 0;
				pp = tmp;
				while (*pp) {
					int n = 0;
					while (isdigit(*pp)) {
						n = (n * 10) + (*pp++ - '0');
					}
					over[no++] = n;
					if (*pp) ch0 = *pp++;
				}
				if (no > 2) {
					from = over[0];
					to = over[no-1];
					ch = 'x';
				} else {
					int x = sscanf(tmp, "%d%c%d", &from, &ch, &to);
				}
			}
			*/
			if (no < 2) {
				no = 0;
				pp = tmp;
				while (*pp) {
					int n = 0;
					while (isdigit(*pp)) {
						n = (n * 10) + (*pp++ - '0');
					}
					over[no++] = n;
					if (*pp) ch0 = *pp++;
				}
			}
			if (no == 2) {
				from = over[0];
				to = over[no-1];
				ch = '-';
			} else if (no > 2) {
				from = over[0];
				to = over[no-1];
				ch = 'x';
			} else {
				int x = sscanf(tmp, "%d%c%d", &from, &ch, &to);
			}
			g.moguci_potezi();
			move = g.MakeMove(from, to);
			free(tmp);
			if (finalComment == NULL) {
				strcat(pname, "_comment");
				free(g.lastComment);
				g.lastComment = getParamValue(p, pname);
				if ((g.lastComment != NULL) && (*(g.lastComment) != '\0')) {
					if ((int)(strlen(partija) + strlen(g.lastComment) + 3) >= psize) {
						psize *= 2;
						partija = (char *)realloc(partija, psize + 1);
					}
					strcat(partija, "(");
					strcat(partija, g.lastComment);
					strcat(partija, ") ");
				}
			}
			if ((n % 2) != 0) {
				int len = strlen(partija);
				if (len >= psize - 2) {
					psize *= 2;
					partija = (char *)realloc(partija, psize + 1);
				}
				partija[len-1] = '\r';
				partija[len] = '\n';
				partija[len+1] = '\0';
			}
		}
		if (finalComment != NULL) {
			g.lastComment = finalComment;
		}
		int select = DoDlgPloca(hwnd, &g);
		for (n=5; --n>=0; DeleteObject(hIcon[n]));
	}
	free(tmp);
	free(bijeli);
	free(crni);
	free(action);
	free(playsWhite);
	free(playsBlack);
	free(partija);

	free(endMessage);


	_CrtDumpMemoryLeaks();

	return 0;
}

void posaljiPotez(char *potez, char *komentar, char *password) {
	char *argn[6] = { "playsWhite", "playsBlack", "MoveParam", "Command", "MoveComment", "password" };
	char *argv[6];
	argv[0] = playsWhite;
	argv[1] = playsBlack;
	argv[2] = potez;
	argv[3] = command;
	argv[4] = komentar;
	argv[5] = password;

	log_file = fopen("c:\\dama.txt", "a");
	char ref[1024];
	sprintf(ref, "http://" HOST "%s", GAME_URL);
	char *b = post(HOST, 80, action, 6, argn, argv, NULL, 0, ref);
	fclose(log_file);
}
